# Copyright (C) 2004 Gregoire Lejeune <gregoire.lejeune@free.fr>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

require "singleton"
require "html/ssi"

module Apache
  class SsiRun
    include Singleton

    def handler(r)
      if r.method_number == M_OPTIONS
        r.allowed |= (1 << M_GET)
        r.allowed |= (1 << M_POST)
        return DECLINED
      end
      if r.finfo.mode == 0
        return NOT_FOUND
      end

      s = r.server( )
      r.setup_cgi_env
	    $:.delete( "." )

      ## Get file and compile code
      filename = r.filename.dup
      filename.untaint

	    hFile = File.open( filename )
	    xContent = hFile.read
	    hFile.close
      
	    print @oSSI.parse( xContent )

      return OK
    end

    private
    def initialize
	    @oSSI = HTML::SSI::new( )
	    @oSSI.vars = ENV.untaint
    end

  end
end
